/* $Id: cpl_imagelist_io_body.h,v 1.23 2008/11/28 11:05:25 lbilbao Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2008 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Type dependent macros */
#if CPL_CLASS == CPL_CLASS_DOUBLE
#define CPL_IMAGE_GET cpl_image_get_data_double
#define CPL_TYPE_T CPL_TYPE_DOUBLE
#define CPL_TYPE double
#define CPL_CFITSIO_TYPE    TDOUBLE

#elif CPL_CLASS == CPL_CLASS_FLOAT
#define CPL_IMAGE_GET cpl_image_get_data_float
#define CPL_TYPE_T CPL_TYPE_FLOAT
#define CPL_TYPE float
#define CPL_CFITSIO_TYPE    TFLOAT

#elif CPL_CLASS == CPL_CLASS_INT
#define CPL_IMAGE_GET cpl_image_get_data_int
#define CPL_TYPE_T CPL_TYPE_INT
#define CPL_TYPE int
#define CPL_CFITSIO_TYPE    TINT

#elif CPL_CLASS == CPL_CLASS_BIN
#define CPL_IMAGE_GET cpl_mask_get_data

#else
#undef CPL_IMAGE_GET
#undef CPL_TYPE_T
#undef CPL_TYPE
#undef CPL_CFITSIO_TYPE
#endif

#if CPL_OPERATION == CPL_IMLIST_IO_LOAD_WIN

    /* Loop on all planes */
    for (i=0 ; i < nplanes ; i++) {
        image = cpl_image_new(urx - llx + 1, ury - lly + 1, CPL_TYPE_T) ;
        pimage = cpl_image_get_data(image) ;
        if (naxis == 3) fpixel[2] = lpixel[2] = i+1 ;
        fits_read_subset(fptr, CPL_CFITSIO_TYPE, fpixel, lpixel, inc, 
                NULL, pimage, NULL, &fio_status) ;
        if (cpl_imagelist_set(imlist, image, i)) break;
        image = NULL;
    }

#endif

#undef CPL_IMAGE_GET
#undef CPL_TYPE_T
#undef CPL_TYPE
#undef CPL_CFITSIO_TYPE
